<?php
// defines certify properties for RDR integration
require 'certify_defines.php';

// Added by ADS on July 14, 2015 - Need a name to refer to the Flash Based UI
//Flex UI Name
define("FLASH_UI_NAME", "Legacy User Interface");

//
// Define Linux volume specifier.
//
define("LINUX_VOLUME", "@@@:");
define("UNKNOWN_ELEMENT", "unknown");
define("LOG_DIRECTORY", "/usr/bp/logs.dir");
define("TIME_FORMAT_12HR", "h:i:sA");

//
// Define backup status field possible values.
//
define("STATUS_SUCCESS", 0);
define("STATUS_WARNING", 1);
define("STATUS_FAILURE", 2);

//
// Generic property identifiers
//
define("GENERIC_CISCO_USC",  0 );
define("GENERIC_CISCO_USCM", 1 );
define("GENERIC_ISR", 		 2 );
define("GENERIC_NEXSUS",     3 );
define("GENERIC_NDMP_NAS",   4 );

//
// Constant for special nodes.
//
define("FILE_LEVEL", 'file-level');
define("VMWARE", "VMware");
define("ORACLE", "Oracle");
define("SHAREPOINT", "SharePoint");
define("NAS_POSTFIX", "-NAS-RRC");
define("HYPERV", "HyperV");
define("SYSTEM_METADATA", "system metadata");
define("INTEGRATED_BM_RESTORE", "integrated bm restore");

$GLOBAL_BACKUP_TYPES 	= array (
								"master",
								"differential",
								"incremental",
								"baremetal",
								"selective",
								"mssql full",
								"mssql differential",
								"mssql transaction",
								"exchange full",
								"exchange differential",
								"exchange incremental",
								"legacy mssql full",
								"legacy mssql diff",
								"legacy mssql trans",
								"vmware full",
								"vmware differential",
								"vmware incremental",
								"hyperv full",
								"hyperv incremental",
								"hyperv differential",
								"oracle full",
								"oracle incr",
								"sharepoint full",
								"sharepoint diff",
								"system metadata",
								"ucs service profile full",
								"integrated bm restore",
								"ndmp full", 
								"ndmp diff", 
								"ndmp incr"
							);

$GLOBAL_SQL_TYPES 		= array (
								"mssql full",
								"mssql differential",
								"mssql transaction",
								"legacy mssql full",
								"legacy mssql diff",
								"legacy mssql trans",
							);

// Use the same types for reports, adding restore and verify.
$GLOBAL_BACKUP_REPORT_TYPES = $GLOBAL_BACKUP_TYPES;
$GLOBAL_BACKUP_REPORT_TYPES[] = "restore";
$GLOBAL_BACKUP_REPORT_TYPES[] = "verify";

$GLOBAL_SS_TYPES 		= array (
								"securesync master",
								"securesync differential",
								"securesync incremental",
								"securesync baremetal",
								"securesync localdir",
								"securesync dpustate",
								"securesync SQL",
								"securesync exchange",
								"securesync msexch full",
								"securesync msexch incr",
								"securesync msexch diff",
								"securesync mssql full",
								"securesync mssql diff",
								"securesync mssql trans",
								"securesync vmware full",
								"securesync vmware diff",
								"securesync vmware incr",
								"securesync hyperv full",
								"securesync hyperv incr",
								"securesync hyperv diff",
								"securesync oracle full",
								"securesync oracle incr",
								"securesync sharepoint full",
								"securesync sharepoint diff", 
								"securesync system metadata",
								"securesync ucs service profile full",
								"securesync ndmp full", 
								"securesync ndmp diff", 
								"securesync ndmp incr"
							);

// 
// root of BPL server-side scripts
//
$rootdir = $_SERVER['DOCUMENT_ROOT'] . "/recoveryconsole/";

// unique separator string used in user management and nvp managment, using in breaking up a php $_GET into sub-pieces
$stringSeparator = 'zxywz';

/*
Updated on 5/29/2014
app_id list generated by either:
 psql -Upostgres bpdb -c "select * from bp.application_lookup order by app_id"
or by bp_get_application_lookup


 app_id |        name         |        type         
--------+---------------------+---------------------
      1 | file-level          | file-level
      2 | Exchange 2003       | Exchange
      3 | Exchange 2007       | Exchange
      4 | Exchange 2010       | Exchange
      5 | Exchange 2013       | Exchange
     21 | SQL Server 2005     | SQL Server
     22 | SQL Server 2008     | SQL Server
     23 | SQL Server 2008 R2  | SQL Server
     24 | SQL Server 2012     | SQL Server
     30 | Archive             | Archive
     40 | VMware              | VMware
     50 | Hyper-V 2008 R2     | Hyper-V
     51 | Hyper-V 2012        | Hyper-V
     60 | System Metadata     | System Metadata
     99 | block-level         | block-level
    100 | Oracle 11           | Oracle
    101 | Oracle 12           | Oracle
    110 | SharePoint 2007     | SharePoint
    111 | SharePoint 2010     | SharePoint
    112 | SharePoint 2013     | SharePoint
    120 | UCS Service Profile | UCS Service Profile
(21 rows)


Select app_id constants:*/
$app_id_file_level = 1;
$app_id_archive = 30;
$app_id_system_metadata = 60;
$app_id_block_level = 99;


// Returns an array populated with the values from the $_REQUEST array specified by the values in the parameter arrays.  
// The keys for the parameter arrays are turned into keys for the returned array.
// @param $infoArray - passed in source array to which entries will be appended
// @param $options - array whose keys will be keys in the resultant array - values will be used to retrieve values from the $_REQUEST
// @param $bOptions - array whose keys will be keys in the resultant array - values will be used to retrieve values from the $_REQUEST
//                  - those values will be converted to a boolean true or false based on the passed in string ( "1"= true, "2"=false )
function buildOptions($infoArray, $options, $bOptions) {
	foreach ($options as $arrayIndex => $commandArgument) {
		if (isset($_REQUEST[$commandArgument])) {
			$value = $_REQUEST[$commandArgument];
			$infoArray = array_merge($infoArray, array($arrayIndex => $value));
		}
	}	
	foreach ($bOptions as $arrayIndex => $commandArgument) {
		if (isset($_REQUEST[$commandArgument])) {
			$value = $_REQUEST[$commandArgument] == "1" ? true : false;
			$infoArray = array_merge($infoArray, array($arrayIndex => $value));						
		} else {
			// default - not true
			$infoArray = array_merge($infoArray, array($arrayIndex => false));		
		}
	}	
	return $infoArray;
}

function addIntegerOptions($infoArray, $options) {
	foreach ($options as $arrayIndex => $commandArgument) {
		if (isset($_GET[$commandArgument])) {
			$value = (int)$_GET[$commandArgument];
			$infoArray = array_merge($infoArray, array($arrayIndex => $value));
		}
	}	
	return $infoArray;
}

function getClientName($BP, $clientID, $systemID, $clients = NULL) {
	$clientName = NULL;
	if ($clients == NULL || $clients == false) {
		$clients = $BP->get_client_list($systemID);
	}
	if (isset($clients[$clientID])) {
		$clientName = $clients[$clientID];
	}
	return $clientName;
}

function getClientID($BP, $clientName, $systemID) {
	$clientID = -1;	
	$clients = $BP->get_client_list($systemID);
	foreach ($clients as $id => $name) {
		if ($clientName == $name) {
			$clientID = $id;
			break;
		}
	}
	return $clientID;
}

function getDeviceName($BP, $deviceID, $systemID, $devices = NULL) {
	$deviceName = NULL;
	if ($devices == NULL || $devices == false) {
		$devices = $BP->get_device_list($systemID);
	}
	if (isset($devices[$deviceID])) {
		$deviceName = $devices[$deviceID];
	}
	return $deviceName;
}

function getDeviceID($BP, $deviceName, $systemID) {
	$deviceID = -1;	
	$devices = $BP->get_device_list($systemID);
	foreach ($devices as $id => $name) {
		if ($deviceName == $name) {
			$deviceID = $id;
			break;
		}
	}
	return $deviceID;
}

function getSystemName($BP, $systemID) {
	$systemName = NULL;	
	$systems = $BP->get_system_list();
	foreach ($systems as $id => $name) {
		if ($systemID == $id) {
			$systemName = $name;
			break;
		}
	}
	return $systemName;
}

function getCrossVaultDpuID($BP, $targetName, $systems = NULL) {
	$crossVaultDpuID = -1;
	$crossVaultDpuName = $targetName . '.dpu';
	if ($systems == NULL || $systems == false) {
		$systems = $BP->get_system_list();
	}
	foreach ($systems as $id => $name) {
		if ($crossVaultDpuName == $name) {
			$crossVaultDpuID = $id;
			break;
		}
	}
	return $crossVaultDpuID;
}

//
// Creates the XML for the backup status node used in multiple php files.  The caller
// specifies the tag name to be used (so that the same routine can generate SDS statuses.
//
function createAlertXML($xml, $alert)
{
	// convert timestamp to local time/day
	$day = date('m/d/Y', $alert['timestamp']);
	$time = date(TIME_FORMAT_12HR, $alert['timestamp']);
	
	$xml->push('Alert', array("Identification" => $alert['id']));
	$xml->element('Date', $day);
	$xml->element('Time', $time);
	$xml->element('Resolved', $alert['resolved'] == true ? 1 : 0);
	$xml->element('Severity', $alert['severity']);
	$xml->element('SourceName', $alert['source_name']);
	$xml->element('Text', $alert['text']);
	$xml->pop(); // 'Alert
}

//
// Creates the XML for the backup status node used in multiple php files.  The caller
// specifies the tag name to be used (so that the same routine can generate SDS statuses.
//
function createBackupStatusXML($xml, $strTag, $backup, $bShowSynthesis = false, $replicatedMetaDataOnly = false) {
	
	// should we skip it?
	if ($replicatedMetaDataOnly == true) {
		$type = isset($backup['type']) ? $backup['type'] : "";
		if ($type == SYSTEM_METADATA) {
			$replicated = isset($backup['replicated']) ? $backup['replicated'] : true;
			if ($replicated === false) {
				return;
			}
		}
		
	}
	//always skip ibmr in backup status displays
	$type = isset($backup['type']) ? $backup['type'] : "";
	if ($type == INTEGRATED_BM_RESTORE) {
			return;
		}
	
	// convert timestamp to local time/day
	$day = date('m/d/Y', $backup['start_time']);
	$time = date(TIME_FORMAT_12HR, $backup['start_time']);
			
	$backupType = getBackupTypeString($backup['type']);
	$bid = isset($backup['id']) ? $backup['id'] : "";

	$xml->push($strTag, array('Type' => $backupType, "Identification" => $bid));
	$xml->element('Date', $day);
	$xml->element('Time', $time);
	if (array_key_exists('elapsed_time', $backup)) {
		$xml->element('ElapsedTime', $backup['elapsed_time']);
	}
	if (array_key_exists('complete', $backup)) {
		$xml->element('Complete', $backup['complete'] == true ? 1 : 0);
	}
	
	// If the backup has completed, note this.
	if (array_key_exists('status', $backup)) {
		switch ($backup['status']) {
			case 0:		$backupStatus = "Success"; break;
			case 1:		$backupStatus = "Warning"; break;
			case 2:		$backupStatus = "Failure"; break;
		}
		$xml->element('Result', $backupStatus);
	}
	
	// If the backup has completed, note this.
	if (array_key_exists('verify_status', $backup)) {
		$xml->element('VerifyResult', $backup['verify_status']);
	}

	if (array_key_exists('size', $backup)) {
		$xml->element('Size', $backup['size']);
	}
	
	if(isset($backup['sync_size'])){
		$xml->element('SyncSize', $backup['sync_size']);
	}
	
	// If the backup has file count, note this.
	if (array_key_exists('files', $backup)) {
		$xml->element('Files', $backup['files']);
	}
	
	// If the backup was encrypted, note this.
	if (array_key_exists('encrypted', $backup)) {
		$xml->element('Encrypted', $backup['encrypted'] == true ? 1 : 0);
	}
	
	// Output sync status
	if (array_key_exists('sync_status', $backup)) {
		$xml->element('SyncStatus', $backup['sync_status']);
	}
	
	// If an MSSQL Type, get instance and database names.
	// If an Exchange or Oracle Type, get database name.
	if (array_key_exists('server_instance_name', $backup)) {
		$xml->element('Instance', $backup['server_instance_name']);
	} else if (isset($backup['sharepoint_guid'])) {
		$xml->element('Instance', $backup['sharepoint_guid']);
	}
	if (array_key_exists('database_name', $backup)) {
		$xml->element('Database', $backup['database_name']);
	} else if (isset($backup['oracle_sid'])) {
		$xml->element('Database', $backup['oracle_sid']);
	} else if (isset($backup['vm_name'])) {
		// return vm_name in the database field for replication history report
		$xml->element('Database', $backup['vm_name']);
	} else if (array_key_exists('ndmp_volume_name', $backup)) {
		$xml->element('Volume', $backup['ndmp_volume_name']);
	}
	// If an application, get instance ID.
	if (array_key_exists('instance_id', $backup)) {
		$xml->element('InstanceID', $backup['instance_id']);
	}
	// If an application, get name and ID.
	if (array_key_exists('app_name', $backup)) {
		$xml->emptyelement('Application', array('Name' => $backup['app_name'])); //, 'ID' => $backup['app_id']));
	}
	// see if synthesized or synthesis capable.
	$xml->element('Synth', (isset($backup['synthesized']) && $backup['synthesized'] == true) ? 1 : 0);
	if ($bShowSynthesis) {
		$xml->element('SynthCapable', (isset($backup['synth_capable']) && $backup['synth_capable'] == true) ? 1 : 0);
	}
	//if hyper-v, is it a cluster?
	if (isset($backup['is_cluster'])) {
		$xml->element('Cluster', $backup['is_cluster'] == true ? 1 : 0);
	}
	
	// See if disk metadata file is present.
	if (isset($backup['disk_metadata'])) {
		$xml->element('Meta', $backup['disk_metadata'] == true ? 1 : 0);
	}
	
		// See if client config is present - used to get config from backup
	if (isset($backup['client_config'])) {
		$xml->element('ClientConfig', $backup['client_config'] == true ? 1 : 0);
	}
	
	//if hyper-v, get the GUID
	if (isset($backup['guid'])) {
		$xml->element('guid', $backup['guid']);
	}
	
	// see if backup is replicated.
	if (isset($backup['replicated']) && $backup['replicated'] == true) {
		$xml->element('Replicated', 1);
	}
	
	// If VMware Template
	if (isset($backup['vmware_template'])) {
		$xml->element('Template', ( $backup['vmware_template'] == 1 ) ? 1 : 0 );
	}
	
	// VSS Support
	if (isset($backup['support_vss_diff'])) {
		$xml->element('VSSDiff', ( $backup['support_vss_diff'] == 1 ) ? 1 : 0 );
	}
	
	// If Certified
	if (isset($backup[STATUS_CERTIFY_API_KEY])) {
		$certifyAttributes = getCertifyStatusAttributesArray($backup[STATUS_CERTIFY_API_KEY]);
		$xml->emptyelement(STATUS_CERTIFY_XML_NODE, $certifyAttributes);
	}			
			
	$xml->pop(); // Backup
}

//
// Creates the XML for the client node used in multiple php files.  Specifies both the local
// and network ID of the client.  The bPopTag argument indicates whether or not we should
// generate the closing client XML tag.  If not, the caller will need to explicitly pop the
// client tag later.
//
function createClientXML($xml, $clientInfo, $id, $networkID, $bPopTag, $Credentials = NULL, $dpuID = NULL)
{
	$xml->push('Client', array('NetworkName' => $clientInfo['name'], 'ID' => $id, 'NetworkIdentification' => $networkID));
	$xml->element("Type", getClientType($clientInfo));
	
	if (array_key_exists('priority', $clientInfo)) {
		$xml->element('Priority', $clientInfo['priority']);
	}
	if (array_key_exists('is_enabled', $clientInfo)) {
		$xml->element('Enabled', $clientInfo['is_enabled'] == true ? "1" : "0");
	}
	if (array_key_exists('is_synchable', $clientInfo)) {
		$xml->element('Synchable', $clientInfo['is_synchable'] == true ? "1" : "0");
	}
	if (array_key_exists('is_encrypted', $clientInfo)) {
		$xml->element('Encrypted', $clientInfo['is_encrypted'] == true ? "1" : "0");
	}
	if (array_key_exists('use_ssl', $clientInfo)) {
		$xml->element('SSL', $clientInfo['use_ssl'] == true ? "1" : "0");
	}
	if (array_key_exists('machine_type', $clientInfo)) {
		$xml->element('MachineType', $clientInfo['machine_type']);
	}
	if (array_key_exists('os_type', $clientInfo)) {
		$xml->element('OS', $clientInfo['os_type']);
	}
	if (array_key_exists('os_type_id', $clientInfo)) {
		$xml->element('OSID', $clientInfo['os_type_id']);
	}
	if (array_key_exists('generic_property', $clientInfo)) {
		$xml->element('GenericProperty', $clientInfo['generic_property']);
	}
	if (array_key_exists('version', $clientInfo)) {
		$xml->element('Version', $clientInfo['version']);
	}
	if (array_key_exists('is_hyperv_cluster', $clientInfo)) {
		$xml->element('Cluster', $clientInfo['is_hyperv_cluster']);
	}
	if (array_key_exists('vendor', $clientInfo)) {
		$xml->element('Vendor', $clientInfo['vendor']);
	}
	if (array_key_exists('remote_port', $clientInfo)) {
		$xml->element('Port', $clientInfo['remote_port']);
	}
	if (array_key_exists('remote_address', $clientInfo)) {
		$xml->element('IP', $clientInfo['remote_address']);
	}
	if (array_key_exists('sockets', $clientInfo)) {
		$xml->element('Sockets', $clientInfo['sockets']);
	}
	if (array_key_exists('applications', $clientInfo)) {
		buildApplicationElements($xml, $clientInfo['applications'], $id, $dpuID);
	}
	
	if ($Credentials != NULL) {
		//$xml->content($credXML->getXML());
		$Credentials->buildXML($xml, $clientInfo['credentials'], 'Credentials');
	}
	
	if ($bPopTag)
		$xml->pop(); // client
}


//
// This function returns the string type of the client.
//
function getClientType($clientInfo)
{
	$clientType = "Computer";
	$name = $clientInfo['name'];
	if (strstr($name, NAS_POSTFIX)) {
		$clientType = "NAS";
	}
	return $clientType;
}

//
// Creates the application XML for the clients.
//
function buildApplicationElements($xml, $applications, $cid, $dpuID) {
	GLOBAL $BP;
	GLOBAL $grandClientView;
	foreach ($applications as $id => $application) {
		
		// Skip file-level application for now.
		if ($application['name'] != FILE_LEVEL) {
			$applicationType = $application['type'];
			$bIsVisible = false;
			
			if(isset($application['visible'])){
				$bIsVisible =  $application['visible'];
			}
			
			// handle case of multiple servers for VMware.
			if ($applicationType == VMWARE) {
				if (isset($application['servers'])) {
					$servers = $application['servers'];
					if (count($servers) > 0) {
						foreach ($servers as $uuid => $serverName) {
							$xml->push('Application', array('NetworkName' => $serverName, 'NetworkIdentification' => $id));
							$xml->element('UUID', $uuid);
							$xml->element('Type', $applicationType);
							$xml->element('Visible', $bIsVisible == true ? "1" : "0");
							
							if($grandClientView){
								$vmwareGrandclientInfo = $BP->get_grandclient_vm_info($serverName, $cid);
								$vmware = false;
							} else {
								$vmware        = $BP->get_vm_info( $uuid, NULL, true, false, $dpuID );
								$resourcePools = $BP->get_resource_pool_info( $uuid, $dpuID );
								$vapps         = $BP->get_vApp_info( $uuid, $dpuID );
								$vmwareGrandclientInfo = false;
							}
							
							if($vmware !== false){
								foreach($vmware as $vm){
									$instanceID = $vm['instance_id'];
									$parentKey = isset( $vm['parentKey'] ) ? $vm['parentKey'] : "";
									$parentType = isset( $vm['parentType'] ) ? $vm['parentType'] : "";
									$name = $vm['name'];
									$isTemplate = isset( $vm['template'] ) && $vm['template'] == 1 ? true : false;

									$xml->push('VM', array('InstanceID' => $instanceID,
														'NetworkIdentification' => $id,
														'Name' => $name,
														'ParentType' => $parentType,
														'ParentKey' => $parentKey,
														'Type' => $isTemplate ? "VMWARE_TMP" : "VMWARE_VM" ));
									$xml->pop();
								}
							}
							
							else if($vmwareGrandclientInfo !== false){
								foreach($vmwareGrandclientInfo as $vm){
									$instanceID = $vm['instance_id'];
									$name = $vm['name'];
									$isTemplate = isset( $vm['template'] ) && $vm['template'] == 1 ? true : false;
									$xml->push('VM', array('InstanceID' => $instanceID,
														'NetworkIdentification' => $id,
														'Name' => $name,
														'Type' => $isTemplate ? "VMWARE_TMP" : "VMWARE_VM" ));
									$xml->pop();
								}
							}
							
							if ( $resourcePools!== false && $resourcePools != NULL ) {
								foreach($resourcePools as $rp ){
									$rpKey = $rp['key'];
									$rpName = $rp['name'];
									$rpParentType = $rp['parentType'];
									$rpParentKey = $rp['parentKey'];
									$xml->push('VG', array( 'Key' => $rpKey,
															'Name' => $rpName,
															'ParentType' => $rpParentType,
															'ParentKey' => $rpParentKey,
															'Type'=>"0"));
									$xml->pop();
								}
							}
							
							if ( $vapps!== false && $vapps != NULL ) {
								foreach($vapps as $va ){
									$vaKey = $va['key'];
									$vaName = $va['name'];
									$vaParentType = $va['parentType'];
									$vaParentKey = $va['parentKey'];
									$xml->push('VG', array( 'Key' => $vaKey,
															'Name' => $vaName,
															'ParentType' => $vaParentType,
															'ParentKey' => $vaParentKey,
															'Type'=> "1"));
									$xml->pop();
								}
							}
							
						$xml->pop();
						}
						
					}
				}
			} else {
				// standard case, one application with one name.
				$xml->push('Application', array('NetworkName' => $application['name'], 'NetworkIdentification' => $id));
				$xml->element('Type', $applicationType);
				$xml->element('Visible', $bIsVisible == true ? "1" : "0");
				
				if($applicationType == "Hyper-V"){
					
					if($grandClientView){
						$hypervGrandclientInfo = $BP->get_grandclient_hyperv_info($cid);
						$hyperv = false;
					} else {
						$hyperv = $BP->get_hyperv_info($cid, true, $dpuID);
						$hypervGrandclientInfo = false;
					}
					
					if($hyperv !== false){
						foreach($hyperv as $vm){
							$xml->push('VM', array('InstanceID' => $vm['instance_id'],
													'NetworkIdentification' => $id,
													'Name' => $vm['name'],
													'GUID' => $vm['guid'],
													'Type' => "HYPER_V_VM"));
							$xml->pop();							
						
						}
					}
					
					else if($hypervGrandclientInfo !== false){
						foreach($hypervGrandclientInfo as $vm){
							$xml->push('VM', array('InstanceID' => $vm['instance_id'],
													'NetworkIdentification' => $id,
													'Name' => $vm['name'],
													'GUID' => $vm['guid'],
													'Type' => "HYPER_V_VM"));
							$xml->pop();							
						
						}
					}
				}

				$xml->pop();
			}
		}
	}
}

//
// Creates the XML for the device node used in multiple php files.  Specifies both the local
// and network ID of the device.
//
function createDeviceXML($xml, $deviceInfo, $id, $networkID)
{
	// Build the Device XML node.
	$xml->push('Device', array('NetworkName' => $deviceInfo['dev_name'], 'ID' => $id, 'NetworkIdentification' => $networkID));
	if (array_key_exists('dev_nr_name', $deviceInfo))
		$xml->element('Folder', $deviceInfo['dev_nr_name']);
	if (array_key_exists('dev_rw_name', $deviceInfo))
		$xml->element('RWName', $deviceInfo['dev_rw_name']);
	if (array_key_exists('dev_cmd_name', $deviceInfo))
		$xml->element('Command', $deviceInfo['dev_cmd_name']);
	if (array_key_exists('capacity', $deviceInfo))
		$xml->element('Capacity', $deviceInfo['capacity']);
	if (array_key_exists('is_online', $deviceInfo))
		$xml->element('Online', $deviceInfo['is_online'] == true ? "1" : "0");
	if (array_key_exists('is_scsi', $deviceInfo))
		$xml->element('SCSI', $deviceInfo['is_scsi'] == true ? "1" : "0");
	if (array_key_exists('use_juke', $deviceInfo))
		$xml->element('Juke', $deviceInfo['use_juke'] == true ? "1" : "0");	
	if (array_key_exists('default', $deviceInfo))
		$xml->element('Default', $deviceInfo['default'] == true ? "1" : "0");
	if (array_key_exists('comment', $deviceInfo))
		$xml->element('Comment', $deviceInfo['comment']);
	if (array_key_exists('maxcnt', $deviceInfo))
		$xml->element('Concurrent', $deviceInfo['maxcnt']);
	if (array_key_exists('blocksize', $deviceInfo))
		$xml->element('Blocksize', $deviceInfo['blocksize']);
	if (array_key_exists('scsi_blocksize', $deviceInfo))
		$xml->element('SCSIBlocksize', $deviceInfo['scsi_blocksize']);
	if (array_key_exists('supports_dedup', $deviceInfo))
		$xml->element('Dedup', $deviceInfo['supports_dedup']);
	if (array_key_exists('storage_id', $deviceInfo))
		$xml->element('Storage', $deviceInfo['storage_id']);
	$xml->pop(); // Device
}



function displayFileList($xml, $BP, $fileList, $dpuID, $id = 0, $levels = 0, $showBranch = false)
{
	foreach ($fileList as $fileInfo) {
		switch ($fileInfo['type']) {
			case 'volume':
					buildVolumeXML($xml, $BP, $fileInfo);
					break;
			case 'directory':
					buildDirectoryXML($xml, $BP, $fileInfo, $dpuID, $id, $levels, $showBranch);
					break;
			case 'file':
			case 'link':
			case 'symlink':
					buildFileXML($xml, $BP, $fileInfo);
					break;
		}

	}
}

function displayClientFileList($xml, $BP, $fileList, $dpuID, $id = 0, $levels = 0, $showBranch = false)
{
	foreach ($fileList as $fileInfo) {
		switch ($fileInfo['type']) {
			case 'volume':
					buildVolumeXML($xml, $BP, $fileInfo, true);
					break;
			case 'directory':
					buildDirectoryXML($xml, $BP, $fileInfo, $dpuID, $id, $levels, $showBranch, true);
					break;
			case 'file':
			case 'link':
			case 'symlink':
					buildFileXML($xml, $BP, $fileInfo, true);
					break;
		}

	}
}

//
// This function builds the volume XML file information.  If reading from a client, the ID is set;
// otherwise, we are reading from a backup and the clientID is -1
//
// Add the View attribute which is the way we want the CMC to show the entry, e.g., remove
// the Linux '@@@:' volume name.
//
// The date time field is always 0 for volumes on backups.
//
function buildVolumeXML($xml, $BP, $fileInfo, $clientFiles = false)
{
	$viewName = $fileInfo['name'] == LINUX_VOLUME ? '' : $fileInfo['name'];
	$directory = isset($fileInfo['directory']) ? $fileInfo['directory'] : "";
	
	$attributes = array(	'Name' => $fileInfo['name'],
							'View' => $viewName,
							'id' => $fileInfo['id'],
							'Directory' => $directory);

	if ($clientFiles == false) {
		$dateTime = "";
		//$permissions = isset($fileInfo['permissions']) ? createPermissionsString($fileInfo['permissions']) : "";
		$LinkTo = isset($fileInfo['link_to']) ? $fileInfo['link_to'] : "";
		$fileSize = sprintf("%.2f", $fileInfo['size']);

		//$attributes['LinkTo'] = $LinkTo;
		$attributes['Date'] = $dateTime;
		$attributes['Size'] = $fileSize;
		//$attributes['Permissions'] = $permissions;
	} else {
		$attributes['isBranch'] = 'true';
	}
	
	$xml->emptyelement('Volume', $attributes);
}

//
// This function builds the directory XML file information.  If reading from a client, the ID is set;
// otherwise, we are reading from a backup and the clientID is -1
//
// Add the View attribute which is the way we want the CMC to show the entry, e.g., remove
// the Linux '@@@:' volume name.
//
function buildDirectoryXML($xml, $BP, $fileInfo, $dpuID, $id, $levels, $showBranch, $clientFiles = false)
{
	$viewName = $fileInfo['name'];
	$directory = isset($fileInfo['directory']) ? $fileInfo['directory'] : "";
	
	$attributes = array(	'Name' => $fileInfo['name'],
							'View' => $viewName,
							'id' => $fileInfo['id'],
							'Directory' => $directory);

	if ($clientFiles == false) {
		$date = date('m/d/Y', $fileInfo['date']);
		$time = date(TIME_FORMAT_12HR, $fileInfo['date']);
		$dateTime = $date . ' ' . $time;
		//$permissions = isset($fileInfo['permissions']) ? createPermissionsString($fileInfo['permissions'], $fileInfo['type']) : "";
		//$LinkTo = isset($fields['link_to']) ? $fileInfo['link_to'] : "";
		$fileSize = sprintf("%.2f", $fileInfo['size']);	

		//$attributes['LinkTo'] = $LinkTo;
		$attributes['Date'] = $dateTime;
		$attributes['Size'] = $fileSize;
		//$attributes['Permissions'] = $permissions;
	}
	
	if (!$showBranch) {
		$xml->push('Directory', $attributes);
	}

	if ($levels > 0 || $showBranch) {
		$entries = $showBranch ? 1 : 0;
		// Check the directory below to see if the directory has any entries.
		// This was previously commented out, but now able to detect if an entry is a directory
		// or not.  If so, add the "isBranch" attribute and set it to true.
		if ($clientFiles == false) {
			/*
			global $filesAPI;
			$fileID = isset($fileInfo['id']) ? $fileInfo['id'] : NULL;
			$fileList = $BP->$filesAPI($id,
									  $directory . $fileInfo['name'] . '/',		// directory name
									  $fileID,									// file ID
									  "",										// lastFile
									  $entries,									// entries (check for 1 file)
									  $dpuID);									// system ID
			 */
			 if (isset($fileInfo['has_children']) && $fileInfo['has_children'] == true) {
				 $fileList = array('test' => 'test');
			 } else {
				 $fileList = array();
			 }
		} else {
			// Give file list count of 1 so isBranch will be set for all directories.
			$fileList = array('test' => 'test');
		}

		if ($fileList === false) {
			$BP->buildResult($xml, false);
		} else {
			if ($showBranch) {
				if (count($fileList) > 0) {
					$attributes['isBranch'] = 'true';
				}
				$xml->push('Directory', $attributes);
			} else {
				$levels--;
				displayFileList($xml, $BP, $fileList, $dpuID, $id, $levels, $showBranch, $clientFiles);
			}
		}		
	}
	$xml->pop(); // directory
}

//
// This function builds the file XML file information.  If reading from a client, the ID is set;
// otherwise, we are reading from a backup and the clientID is -1
//
// Add the View attribute which is the way we want the CMC to show the entry, e.g., remove
// the Linux '@@@:' volume name.
//
function buildFileXML($xml, $BP, $fileInfo, $clientFiles = false)
{
	$viewName = $fileInfo['name'];
	$directory = isset($fileInfo['directory']) ? $fileInfo['directory'] : "";
	
	$attributes = array(	'Name' => $fileInfo['name'],
							'View' => $viewName,
							'id' => $fileInfo['id'],
							'Directory' => $directory);

	if ($clientFiles == false) {
		$date = date('m/d/Y', $fileInfo['date']);
		$time = date(TIME_FORMAT_12HR, $fileInfo['date']);
		$dateTime = $date . ' ' . $time;
		//$permissions = isset($fileInfo['permissions']) ? createPermissionsString($fileInfo['permissions'], $fileInfo['type']) : "";
		//$LinkTo = isset($fields['link_to']) ? $fileInfo['link_to'] : "";
		$fileSize = is_int($fileInfo['size']) ? $fileInfo['size'] : sprintf("%.2f", $fileInfo['size']);
		
		//$attributes['LinkTo'] = $LinkTo;
		$attributes['Date'] = $dateTime;
		$attributes['Size'] = $fileSize;
		//$attributes['Permissions'] = $permissions;
	}
	
	$xml->emptyelement('File', $attributes);
}

// Create and return an 'rwxrwxrwx' string, given a binary permission value.
// If a special file type (link, symlink), prepend it to the string.
function createPermissionsString($perm, $fileType = 'file')
{
	$strType = ($fileType == 'symlink' || $fileType == 'link') ? 'l' : '';
	
	$strOwner = '';
	$strOwner .= ($perm & 0x0100) ? 'r' : '-';
	$strOwner .= ($perm & 0x0080) ? 'w' : '-';
	$strOwner .= ($perm & 0x0040) ? 'x' : '-';
	
	$strGroup  = '';
	$strGroup .= ($perm & 0x0020) ? 'r' : '-';
	$strGroup .= ($perm & 0x0010) ? 'w' : '-';
	$strGroup .= ($perm & 0x0008) ? 'x' : '-';
	
	$strWorld = '';
	$strWorld .= ($perm & 0x0004) ? 'r' : '-';
	$strWorld .= ($perm & 0x0002) ? 'w' : '-';
	$strWorld .= ($perm & 0x0001) ? 'x' : '-';
	
	return $strType . $strOwner . $strGroup . $strWorld;
}

// This function returns the number formatted with a maximum of 2 digits of precision.
function toNumberString($var)
{
	$formattedString = is_int($var) ? $var : sprintf("%.2f", $var);
	return $formattedString;
}


//
// This function returns a formatted string of the backup type field.
//
function getBackupTypeString($backupField, $bNewBareMetal = false)
{
	$backupType = $backupField;			
	switch ($backupField) {
		case "master":
		case "securesync master":
				$backupType = "Master";
				break;
		case "differential":
		case "securesync differential":
				$backupType = "Differential";
				break;
		case "incremental":
		case "securesync incremental":
				$backupType = "Incremental";
				break;
		case "selective":
				$backupType = "Selective";
				break;
		case "baremetal":
		case "securesync baremetal":
				$backupType = "BareMetal";
				break;
		case "securesync mssql full":
		case "mssql full":
				$backupType = "SQL Full";
				break;
		case "securesync mssql diff":
		case "mssql differential":
				$backupType = "SQL Differential";
				break;
		case "securesync mssql trans":
		case "mssql transaction":
				$backupType = "SQL Transaction";
				break;
		case "legacy mssql full":
		case "legacy mssql diff":
		case "legacy mssql trans":
				$backupType = "SQL";
				break;
		case "securesync msexch full":
		case "exchange full":
				$backupType = "Exchange Full";
				break;
		case "securesync msexch diff":
		case "exchange differential":
				$backupType = "Exchange Differential";
				break;
		case "securesync msexch incr":
		case "exchange incremental":
				$backupType = "Exchange Incremental";
				break;
		case "securesync vmware full":
		case "securesync esx vm full":
		case "vmware full":
				$backupType = "VMware Full";
				break;
		case "securesync vmware diff":
		case "securesync esx vm diff":
		case "vmware differential":
				$backupType = "VMware Differential";
				break;
		case "securesync vmware incr":
		case "securesync esx vm incr":		
		case "vmware incremental":
				$backupType = "VMware Incremental";
				break;
		case "vmware configuration":		// only used on restore for first job to restore metadata
				$backupType = "VMware Configuration";
				break;
		case "securesync hyperv full":
		case "securesync hyper-v full":		// operation progress string
		case "hyperv full":
				$backupType = "Hyper-V Full";
				break;
		case "securesync hyperv incr":
		case "securesync hyper-v incr":		// operation progress string
		case "hyperv incremental":
				$backupType = "Hyper-V Incremental";
				break;	
		case "securesync hyperv diff":
		case "securesync hyper-v diff":		// operation progress string
		case "hyperv differential":
				$backupType = "Hyper-V Differential";
				break;						
		case "restore":
				$backupType = "Restore";
				break;
		case "virtual restore":
				$backupType = "Virtual Restore";
				break;
		case "verify":
				$backupType = "Verify";
				break;
		case "securesync SQL":
		case "securesync sql":
				$backupType = "SQL";
				break;
		case "localdir":
		case "securesync localdir":
				$backupType = "Local Directory";
				break;
		case "securesync exchange":
				$backupType = "Exchange";
				break;
		case "securesync dpustate":
				$backupType = "DPUstate";
				break;
		case "securesync system metadata":
		case "system metadata":
				$backupType = "System Metadata";
				break;
		case "archive":
				$backupType = "Archive";
				break;
		case "archive restore":
				$backupType = "Archive Restore";
				break;
		case "securesync oracle full":
		case "oracle full":
				$backupType = "Oracle Full";
				break;
		case "securesync oracle incr":
		case "oracle incr":
				$backupType = "Oracle Incremental";
				break;
		case "securesync sharepoint full":
		case "sharepoint full":
				$backupType = "SharePoint Full";
				break;
		case "securesync sharepoint diff":
		case "sharepoint diff":
				$backupType = "SharePoint Differential";
				break;
		case "securesync ucs service profile full":
		case "ucs service profile full":
				$backupType = "UCS Service Profile Full";
				break;
		case "integrated bm restore":
				$backupType = "Integrated Bare Metal Recovery";
				break;	
		case "securesync ndmp full":
		case "ndmp full":
				$backupType = "NDMP Full";
				break;	
		case "securesync ndmp diff":
		case "ndmp diff":
				$backupType = "NDMP Differential";
				break;	
		case "securesync ndmp incr":
		case "ndmp incr":
				$backupType = "NDMP Incremental";
				break;	

	}
	return $backupType;
}

//
// This function returns true if a file-based backup type.
//
function isFileBasedBackup($backupType)
{
	$result = false;
	switch ($backupType) {
		case "master":
		case "incremental":
		case "differential":
		case "selective":
			$result = true;
			break;
	}
	return $result;
}

function getBackupStatusString($backup)
{
	$backupStatus = "";
	switch ($backup['status']) {
		case STATUS_SUCCESS:		$backupStatus = "Success"; break;
		case STATUS_WARNING:		$backupStatus = "Warning"; break;
		case STATUS_FAILURE:		$backupStatus = "Failure"; break;
		default:					$backupStatus = ""; break;
	}
	return $backupStatus;
}

function createShortBackupStatusXML($xml, $backup, $dpuName, $clientName)
{
	$backupType	= getBackupTypeString($backup['type']);
	$xml->push("Backup", array('Type' => $backupType, "Identification" => $backup['id'], "DPUName" => $dpuName, "ClientName" => $clientName));
	$day = date('m/d/Y', $backup['start_time']);
	$time = date(TIME_FORMAT_12HR, $backup['start_time']);
	$xml->element('Date', $day);
	$xml->element('Time', $time);
	if (array_key_exists('status', $backup)) {
		$backupStatus = getBackupStatusString($backup);
		$xml->element('Result', $backupStatus);
	}
	
	// If an application, get name and ID.
	if (array_key_exists('app_name', $backup)) {
		if ($backup['app_name'] != FILE_LEVEL) {
			$xml->emptyelement('Application', array('Name' => $backup['app_name']));
		}
		// If an MSSQL Type, get instance and database names.
		// If an Exchange Type, get database name.
		if (array_key_exists('instance_name', $backup)) {
			$xml->element('Instance', $backup['instance_name']);
		}
	}
	$xml->pop();
						
}

//
// Define incremental calendars and strategies
//
define("INC_DIFF_MASTER", 'Friday Master, Daily Diff, Hourly Incr');
define("INC4EVER", 'Incremental Forever');

//
// See if the sysetm supports incrementals and if the name is valid or not.
//
function validIncrementalItem($incrSupported, $name, $readOnly = true) {
	$result = true;
	if (!$incrSupported) {
		if ($readOnly) {
			if ($name == INC_DIFF_MASTER || $name == INC4EVER) {
				$result = false;
			}
		}
	}
	return $result;
}

function getReplicationAndVaultingStatus($systemID, $applications, $isLocalSystem = NULL) {
	GLOBAL $BP;
	GLOBAL $Log;
	
	$replicating = false;					// system is replicating
	$replicationSupported = false;			// system supports replication
	$vaulting = false;						// system is vaulting
	$target = false;						// replication or vaulting target
	$isOnlyManaged = false;					// remote system is replicating/vaulting elsewhere, it is only being managed
	
	if ($isLocalSystem == NULL) {
		$localID = $BP->get_local_system_id();
		// if the id is the same as the local system, it's the local.
		if ($systemID == $localID) {
			$local = true;
		} else {
			$systemInfo = $BP->get_system_info($systemID);
			// If the remote systemID a virtual DPU, handle as a local system.
			if ($systemInfo !== false && $systemInfo['host'] == 'localhost') {
				$local = true;
			}
		}
	}
	
	if ($isLocalSystem === true) {
		$replicationSupported = $BP->replication_supported();
		if ($replicationSupported === true) {
			$replicating = $BP->local_system_is_replicating();
			if (is_string($replicating)) {
				$target = $replicating;
				$replicating = true;
			}
		}
		if ($replicating == false) {
			$vaulting = $BP->local_system_is_vaulting();
			if (is_string($vaulting)) {
				$target = $vaulting;
				$vaulting = true;
			}
		}
	} else {
		// it's a remote, see if replicating or vaulting.
		$replicationSupported = $BP->replication_supported($systemID);
		if ($replicationSupported === true) {
			$replicating = $BP->is_replication_configured($systemID);
			// one more case.  The remote system may be vaulting somewhere else, so read
			// the variables directly to see if vaulting configured or not.
			$target = $BP->get_ini_value('Replication', 'SyncTo', $systemID);
			if (!$replicating && $target !== false && $target != "") {
				// remote system is not replicating to the local system
				$isOnlyManaged = true;
				// see if the target is in the hosts file.
				$hostInfo = $BP->get_host_info($target, $systemID);
				if ($hostInfo !== false) {
					$replicating = true;
				}
			}
		}
		if ($replicating == false) {
			$vaulting = $BP->is_vaulting_configured($systemID);
			$target = $BP->get_ini_value('Securesync', 'SyncTo', $systemID);
			if (!$vaulting && $target !== false && $target != "") {
				// remote system is not vaulting to the local system
				$isOnlyManaged = true;
				$vaulting = true;
			}
		}
		
		//$Log->writeVariable("systemID : $systemID, replicating : $replicating, replicationSupported : $replicationSupported, vaulting : $vaulting, target : $target, isOnlyManaged : $isOnlyManaged");
				
		$result = array (
			'replicating' => $replicating,
			'replicationSupported' => $replicationSupported,
			'vaulting' => $vaulting,
			'target' => $target,
			'isOnlyManaged' => $isOnlyManaged
		);
		
		return $result;	
	}
}

function checkSNMPoptions($options, $bOptions)
{
	$rval = true;
	foreach ($options as $arrayIndex => $commandArgument) {
		if (isset($_REQUEST[$commandArgument])) {
			$value = $_REQUEST[$commandArgument];
			if (strpos($value, '`') !== FALSE) {
			   $rval = false;
			}
			if (strpos($value, '$') !== FALSE) {
			   $rval = false;
			}
			if (strpos($value, '%') !== FALSE) {
			   $rval = false;
			}
		}
	}
	foreach ($bOptions as $arrayIndex => $commandArgument) {
		if (isset($_REQUEST[$commandArgument])) {
			$value = $_REQUEST[$commandArgument];
			if (strpos($value, '`') !== FALSE) {
			   $rval = false;
			}
			if (strpos($value, '$') !== FALSE) {
			   $rval = false;
			}
			if (strpos($value, '%') !== FALSE) {
			   $rval = false;
			}
		}
	}
	if ($rval == false) {
	   $msg = date('Y-m-d H:i:s')." defines.php: detected invalid SNMP parameter\n";
	   file_put_contents('/usr/bp/logs.dir/gui_root.log',$msg,FILE_APPEND);
	}
	return $rval;
}

// processes return of instances separated by pipes
// need to transfer replication report to call this common function instead
function processInstanceName( $instanceNameRaw, $type, $defaultName ) {	
	if ( $instanceNameRaw === NULL || $instanceNameRaw == "" ) {
		$instanceNameRaw = $defaultName;
	}
	
	if( strpos( $instanceNameRaw, "|" ) !== false ) {
		$instanceParts = explode( "|", $instanceNameRaw );
		
		if ( strpos( $type, "VMware" ) !== false || strpos( $type, "SQL" ) !== false ) {
			$instanceParts = array_reverse( $instanceParts );
		}
		return $instanceParts[0];
	}
	
	return $instanceNameRaw;	
}
?>
