<?php
// defines BP, xml, action, cookie
require 'header.php';

// initialize snmp info.
$snmp = array();

$bValid = true;

$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

switch ($action) {
	case "list":
			$snmpArray = $BP->get_snmp_config($dpuID);
			if ($snmpArray !== false) {
				buildSNMPList($xml, $snmpArray);
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
		
	case "change":
	case "update":
			// if updating, specify id
			if (isset($_GET['id'])) {
				$id = (int)$_GET['id'];
				$snmp['id'] = $id;
			} else {
				$BP->buildResult($xml, false, "error: when updating an SNMP setting, the id must be specified.");
				$bValid = false;
			}
			// fall through to add.
	
	case "add":
			$options = array ('destination' => 'dest',
						  'community' => 'comm');
			$bOptions = array('enabled' => 'enabled');		
			$bValid = checkSNMPoptions($options,$bOptions);
			if ($bValid) {	
				// When saving snmp config, specify destination, community string, and enabled/disabled.
				$snmp = buildOptions($snmp, $options, $bOptions);									
				$BP->buildResult($xml, $BP->save_snmp_config($snmp, $dpuID));
			}
			echo($xml->getXml());			
			break;

	case "delete":
			// If deleting snmp config, specify hostname or IP.
			if (isset($_GET['id'])) {
				$id = (int)$_GET['id'];
				$BP->buildResult($xml, $BP->delete_snmp_config($id, $dpuID));
			} else {
				$BP->buildResult($xml, false, "ID must be specified when removing SNMP configuration.");
			}
			echo($xml->getXml());
			break;
			
	case "test":
			$BP->buildResult($xml, $BP->send_test_snmptrap($dpuID));
			echo($xml->getXml());
			break;
			
	case "history":
			$snmpArray = $BP->get_snmp_history($dpuID);
			if ($snmpArray !== false) {
				buildSNMPHistory($xml, $snmpArray);
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
}

//
// Creates the XML list of SNMP targets.
//
function buildSNMPList($xml, $snmpArray)
{
	$xml->push("root");
	foreach ($snmpArray as $snmp) {
		$xml->push("SNMP");
		if (array_key_exists('id', $snmp)) {
			$xml->element('ID', $snmp['id']);
		}
		if (array_key_exists('destination', $snmp)) {
			$xml->element('Destination', $snmp['destination']);
		}
		if (array_key_exists('community', $snmp)) {
			$xml->element('Community', $snmp['community']);
		}
		if (array_key_exists('enabled', $snmp)) {
			$xml->element('Enabled', $snmp['enabled'] == true ? "1" : "0");
		}
		$xml->pop();
	}
	$xml->pop();
}

//
// Creates the XML list of SNMP history.
//
function buildSNMPHistory($xml, $snmpArray)
{
	$xml->push("root");
	foreach ($snmpArray as $snmp) {
		$xml->push("SNMP");
		if (array_key_exists('oid', $snmp)) {
			$xml->element('OID', $snmp['oid']);
		}
		if (array_key_exists('time_sent', $snmp)) {
			$xml->element('TimeSent', $snmp['time_sent']);
		}
		if (array_key_exists('destination', $snmp)) {
			$xml->element('Destination', $snmp['destination']);
		}
		if (array_key_exists('community', $snmp)) {
			$xml->element('Community', $snmp['community']);
		}
		if (array_key_exists('traptype', $snmp)) {
			$xml->element('Type', $snmp['traptype']);
		}
		if (array_key_exists('object', $snmp)) {
			$xml->element('Object', $snmp['object']);
		}
		if (array_key_exists('description', $snmp)) {
			$xml->element('Description', $snmp['description']);
		}
		if (array_key_exists('severity', $snmp)) {
			$xml->element('Severity', $snmp['severity']);
		}
		if (array_key_exists('status', $snmp)) {
			$xml->element('Status', $snmp['status']);
		}
		$xml->pop();
	}
	$xml->pop();
}

$BP->destroyCookie();
?>
