<?php
// defines BP, xml, action, cookie
require 'header.php';

// initialize snmpd (snmp agent) info.
$snmpd = array();

$bValid = true;

$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

switch ($action) {
	case "list":
			$snmpdConfig = $BP->get_snmpd_config($dpuID);
			if ($snmpdConfig !== false) {
				buildSNMPDList($xml, $snmpdConfig);
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
	
	case "update":
			$options = array ('community' => 'comm');
			$bOptions = array('enabled' => 'enabled');
			$bValid = checkSNMPoptions($options,$bOptions);
			if ($bValid) {	
				// When saving snmpd (snmp agent) config, specify community string and enabled/disabled.
				$snmpd = buildOptions($snmpd, $options, $bOptions);									
				$BP->buildResult($xml, $BP->save_snmpd_config($snmpd, $dpuID));
			}
			echo($xml->getXml());			
			break;
}

//
// Creates the XML for configuring SNMPD (SNMP Agent)
//
function buildSNMPDList($xml, $snmpdConfig)
{
	$xml->push("root");
	$xml->push("SNMPD");
	if (array_key_exists("community", $snmpdConfig)) {
		$xml->element("Community", $snmpdConfig["community"]);
	}
	if (array_key_exists("enabled", $snmpdConfig)) {
		$xml->element("Enabled", $snmpdConfig["enabled"] == true ? "1" : "0");
	}
	$xml->pop();
	$xml->pop();
}

$BP->destroyCookie();
?>
